## dpdk 24.11.2

=== examples/l3fwd-graph/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(C) 2020 Marvell International Ltd.

# binary name
APP = l3fwd-graph

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/pipeline/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2020 Intel Corporation

# binary name
APP = pipeline

# all source are stored in SRCS-y
SRCS-y += cli.c
SRCS-y += conn.c
SRCS-y += main.c
SRCS-y += obj.c
SRCS-y += thread.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -I. -DALLOW_EXPERIMENTAL_API -D_GNU_SOURCE

OBJS := $(patsubst %.c,build/%.o,$(SRCS-y))

build/%.o: %.c Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) -c $< -o $@

build/$(APP)-shared: $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP)* build/*.o
	test -d build && rmdir -p build || true

=== examples/rxtx_callbacks/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2015 Intel Corporation

# binary name
APP = rxtx_callbacks

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== drivers/net/bnxt/hcapi/cfa_v3/tpm/CMakeLists.txt ===
#
# Copyright(c) 2021 Broadcom Limited, all rights reserved
# Contains proprietary and confidential information.
#
# This source file is the property of Broadcom Limited, and
# may not be copied or distributed in any isomorphic form without
# the prior written consent of Broadcom Limited.
#

add_library(cfa-tpm-lib-common INTERFACE)
target_include_directories(cfa-tpm-lib-common INTERFACE include
						../include
						../../include
						../../generic-common/include
						../../../tf_core)

set (CFA_TPM_SRCS cfa_tpm.c)

# Production version
add_library(cfa-tpm-lib STATIC EXCLUDE_FROM_ALL ${CFA_TPM_SRCS})
set_property(TARGET cfa-tpm-lib PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-tpm-lib PUBLIC cfa-tpm-lib-common nxt-platform nxt-arch)
target_include_directories(cfa-tpm-lib PUBLIC ../include/platform/fw)

# UT version
add_library(cfa-tpm-lib-ut STATIC EXCLUDE_FROM_ALL ${CFA_TPM_SRCS})
set_property(TARGET cfa-tpm-lib-ut PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-tpm-lib-ut PUBLIC cfa-tpm-lib-common nxt-ut nxt-platform nxt-arch nxt-env-ut)
target_include_directories(cfa-tpm-lib-ut PUBLIC ../include/platform/ut)

set(ignoreMe "${SKIP_TPM_UT}")
if(NOT DEFINED SKIP_TPM_UT)
add_subdirectory(ut)
endif()

# Update Doxygen Path for tpm api documentation
set(CFA_API_DOC_DIRS ${CFA_API_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}/include # Public api
	CACHE INTERNAL "")

# Update Doxygen Path for tpm design documentation
set(CFA_DESIGN_DOC_DIRS ${CFA_DESIGN_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}         # tpm implementation
	CACHE INTERNAL "")

=== debian/changelog ===
dpdk (24.11.2-0ubuntu0.25.04.2) plucky-security; urgency=medium

  * SECURITY UPDATE: DoS and info disclosure in mlx5
    - debian/patches/CVE-2025-23259.patch: fix out-of-order completions in
      ordinary Rx burst in drivers/net/mlx5/linux/mlx5_verbs.c,
      drivers/net/mlx5/mlx5_devx.c, drivers/net/mlx5/mlx5_ethdev.c,
      drivers/net/mlx5/mlx5_rx.c, drivers/net/mlx5/mlx5_rx.h,
      drivers/net/mlx5/mlx5_rxq.c.
    - CVE-2025-23259

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 07 Oct 2025 08:53:28 -0400

dpdk (24.11.2-0ubuntu0.25.04.1) plucky; urgency=medium

  * Merge stable release 24.11.2 (LP: #2067480)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-24.11/rel_notes/release_24_11.html#id1

 -- Arif Ali <arif.ali@canonical.com>  Tue, 06 May 2025 06:56:35 +0000

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 13),
               dh-package-notes,
               dh-python,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               libxdp-dev,
               meson (>= 0.47.1~),
               pkgconf,
               python3:any,
               python3-pyelftools,
               zlib1g-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               inkscape <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 ppc64el riscv64 loong64
Depends: pci.ids | hwdata,
         pciutils,
         procps,
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool25,
            librte-mempool-ring25,
            librte-net-af-packet25,
            librte-net-bond25,
            librte-net-e1000-25,
            librte-net-fm10k25,
            librte-net-i40e25,
            librte-net-ixgbe25,
            librte-net-mlx4-25,
            librte-net-mlx5-25,
            librte-net-netvsc25,
            librte-net-pcap25,
            librte-net-tap25,
            librte-net-thunderx25,
            librte-net-vdev-netvsc25,
            librte-net-vhost25,
            librte-net-virtio25,
            librte-net-vmxnet3-25,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-common,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 24.11~rc1-1),
Replaces: dpdk-dev (<< 24.11~rc1-1),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-common
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Common},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (common libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte common libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 ppc64el riscv64 loong64
Breaks: dpdk (<< 24.11~rc1-1),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${python3:Recommends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         libxdp-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl25
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${shlibs:Depends},
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
